----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:22:03 05/06/2014 
-- Design Name: 
-- Module Name:    volume - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--use IEEE.STD_LOGIC_SIGNED.ALL;
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity volume_control is
    Port (
				LeftIn 	: in  STD_LOGIC_VECTOR (23 downto 0);
				RightIn 	: in  STD_LOGIC_VECTOR (23 downto 0);
				LeftOut 	: out STD_LOGIC_VECTOR (23 downto 0);
				RightOut : out STD_LOGIC_VECTOR (23 downto 0);
				volume 	: in  STD_LOGIC_VECTOR (6 downto 0)
			 );
end volume_control;

architecture Behavioral of volume_control is

begin

RightOut <= (RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23 downto 7)) when volume(6) = '1' else
				(RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23 downto 6)) when volume(5) = '1' else
				(RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23 downto 5)) when volume(4) = '1' else
				(RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23 downto 4)) when volume(3) = '1' else
				(RightIn(23) & RightIn(23) & RightIn(23) & RightIn(23 downto 3)) when volume(2) = '1' else
				(RightIn(23) & RightIn(23) & RightIn(23 downto 2)) when volume(1) = '1' else
				(RightIn(23) & RightIn(23 downto 1)) when volume(0) = '1' else
				RightIn;
				
LeftOut  <= (LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23 downto 7)) when volume(6) = '1' else
				(LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23 downto 6)) when volume(5) = '1' else
				(LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23 downto 5)) when volume(4) = '1' else
				(LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23 downto 4)) when volume(3) = '1' else
				(LeftIn(23) & LeftIn(23) & LeftIn(23) & LeftIn(23 downto 3)) when volume(2) = '1' else
				(LeftIn(23) & LeftIn(23) & LeftIn(23 downto 2)) when volume(1) = '1' else
				(LeftIn(23) & LeftIn(23 downto 1)) when volume(0) = '1' else
				LeftIn;
				
end Behavioral;

